#! /usr/bin/perl -w

#this should take a clans file, a cd-hit cluster file and a user-supplied file, look for which of the user-supplied sequence names were replaced in the the cd-hit clstr file by what other sequence, then take the clans file and add the user-supplied name to the end of the reference sequence name

$userfile="search_cdhit_for_references.txt";
#NOTE: format should be per line one entry
#example:>gi|6679269 Mus_musculus_Pdx-1
$clstrfile="ParaHox.HD63.hms.gi.FLseq.spec.70.clstr";
$clansfile="ClansFL/FL_HD63prot_e-50_annot_final_sel1";
$outfile="FL_HD63prot_e-50_annot_final_sel1_addednames";

open(INFILE,"<$userfile") or die "ERROR, unable to open $userfile\n";
print STDERR "reading userfile\n";
%userhash=();
while($inline=<INFILE>){
    if($inline=~/(gi\|\d+)/o){
	$userhash{$1}=$inline;
    }
}
close INFILE;
open(INFILE,"<$clstrfile") or die "ERROR, unable to open $clstrfile\n";
print STDERR "reading clstr file\n";
$refname="";
@refarr=();
%refhash=();
while($inline=<INFILE>){
    if($inline=~/>Cluster/o){
	if(scalar @refarr>0){
	    foreach $line(@refarr){
		if($line=~/(gi\|\d+).*\s\*\s*$/o){
		    $refname=$1;
		}
	    }
	    foreach $line(@refarr){
		if($line=~/(gi\|\d+).*\sat/o){
		    if(defined($userhash{$1})){
			my @tmp=();
			if(defined $refhash{$refname}){
			    @tmp=@{$refhash{$refname}};
			}
			push @tmp,$1;
			$refhash{$refname}=\@tmp;
		    }
		}
	    }
	}
	$refname="";
	@refarr=();
    }else{
	push @refarr,$inline;
    }
}
close INFILE;

open(INFILE,"<$clansfile") or die "ERROR, unable to open $clansfile\n";
print STDERR "reading clans file\n";
open(OUTFILE,">$outfile") or die "ERROR< unable to open '$outfile' for writing\n";
%donehash=();
while($inline=<INFILE>){
    if($inline=~/(gi\|\d+)/o){
	if(defined $refhash{$1}){
	    chomp $inline;
	    my @arr=@{$refhash{$1}};
	    $outline=$inline." CDHITREF for:";
	    foreach $val(@arr){
		$outline.=" ".$userhash{$val}." | ";
		$donehash{$val}=1;
	    }
	    print OUTFILE $outline."\n";
	}else{
	    print OUTFILE $inline;
	}	
    }else{
	print OUTFILE $inline;
    }    
}
close OUTFILE;
close INFILE;

@failedarr=();
foreach $val(keys %userhash){
    if(defined $donehash{$val}){
	#everything ok
    }else{
	push @failedarr,$val;
    }
}
if(scalar @failedarr>0){
    print STDERR "No cd-hit reference found for:";
    foreach $val(@failedarr){
	print "\t$val\n";
    }
}
