#! /usr/bin/perl -w
#add the ncbi taxonomy to each of the fasta sequences (containing gi-numbers)

if(scalar @ARGV==0){
    die "usage: perl program_name sequence_file\n";
}
$namesfile="/databases/names.dmp";
$taxid="/databases/gi_taxid_prot.dmp";

#$namesfile="/raid/opt/databases/taxonomy/names.dmp";
#$taxid="/raid/opt/databases/taxonomy/gi_taxid_prot.dmp";
#$taxid="/raid/opt/databases/taxonomy/gi_taxid_nucl.dmp";

%nameshash=();
print STDERR "reading $ARGV[0]\n";
open(INFILE,"<$ARGV[0]") or die "unable to open $ARGV[0] for reading\n";
$currname="";
$fullname="";
$currseq="";
while($inline=<INFILE>){
    if($inline=~/^\s*>(.*)/o){
	if(length $currseq>0){
	    $nameshash{$currname}=$fullname."\n".$currseq;
	}
	$currseq="";
	$fullname=$1;
	$currname=$inline;
	if($currname=~/\s*>\s*(\S+)/o){
	    $currname=$1;
	}
    }else{
	$currseq.=$inline;
    }
}
if(length $currseq>0){
    $nameshash{$currname}=$fullname.$currseq;
}	
close INFILE;

print STDERR "read ".(scalar keys %nameshash)." sequences\n";
#now I have all the sequences and their names in a hash
#next, create a gi-hash lookup
%gihash=();
foreach $name(keys %nameshash){
    if($name=~/gi\|(\d+)\|/o){
	$gihash{$1}=$name;
	print STDERR "gi number: $1\n";
    }else{
	print STDERR "no gi number for '$name'\n";
    }
}

#now I read through the taxid file and set the corresponding taxonomy id's
%gitaxhash=();
%spechash=();
print STDERR "reading '$taxid'\n";
open(INFILE,"<$taxid") or die "unable to open '$taxid' for reading\n";
@tmparr=();
while($inline=<INFILE>){
    @tmparr=split /\s+/,$inline;
    if(defined $gihash{$tmparr[0]}){
	$gitaxhash{$tmparr[0]}=$tmparr[1];
	$spechash{$tmparr[1]}="undef";
	print STDERR "found taxid $tmparr[1] for $tmparr[0]\n";
    }
}
close INFILE;

#and now read through the names.dmp file and get the corresponding name
print STDERR "reading '$namesfile'\n";
open(INFILE,"<$namesfile") or die "unable to open $namesfile\n";
while($inline=<INFILE>){
    @tmparr=split /\s*\|\s+/,$inline;
    if(defined $spechash{$tmparr[0]} && ($inline=~/scientific name/o)){
	$spechash{$tmparr[0]}=$tmparr[1];
	print STDERR "found species name $tmparr[1] for $tmparr[0]\n";
    }
}
close INFILE;

#now print out the data
$species="";
foreach $name (sort keys %nameshash){
    if($name=~/gi\|(\d+)\|/o){
	$ginum=$1;
	if(defined $gitaxhash{$ginum}){
	    if(defined $spechash{$gitaxhash{$ginum}}){
		$species="[".$spechash{$gitaxhash{$ginum}}."]";
	    }
	}else{
	    $species="[]";
	}
    }else{
	$species="";
    }
    print ">".$name." ".$species." ".$nameshash{$name}."\n";
}
print STDERR "DONE\n";
